io8255_port_a    equ 230h       ; 8255˿AַΪ230h
io8255_port_b    equ 231h       ; 8255˿BַΪ231h
io8255_port_c    equ 232h       ; 8255˿CַΪ232h
io8255_control   equ 233h       ; 8255ƼĴַΪ233h
io8253_channel_0 equ 210h       ; 8253ͨ0ַΪ210h
io8253_channel_1 equ 211h       ; 8253ͨ1ַΪ211h
io8253_control   equ 213h       ; 8253ƼĴַΪ213h
io8259_master    equ 200h       ; 8259ַΪ200h
io8259_slave     equ 201h       ; 8259ӿַΪ201h
ad_start         equ 220h       ; ADתʼƵַΪ220h
ad_output_enable equ 221h       ; ADʹַܵΪ221h
ad_end_of_conv   equ 222h       ; ADת־ַΪ222h

; ݶζ
data        segment
    interrupt_count dw  0               ; жϼ¼жϴ
    traffic_light_states db  0ch,14h,21h,22h,0ffh   ; ͨƵ״̬
    adc_value           db  ?               ; 洢ADתֵ
    motor_phase         db  0               ; 
data        ends

; ջζ
stack_segment segment stack
    db  256 dup(?)  ; ջСΪ256ֽ
stack_segment ends

; ζ
code    segment
    assume  cs:code, ds:data, ss:stack_segment
start:
    cli                       ; ж
    mov ax, data              ; ݶεֵַaxĴ
    mov ds, ax                ; axĴֵdsĴ

    ; ʼ8259оƬ
    mov dx, io8259_master      ; io8259_masterĵֵַdxĴ
    mov al, 00010011b         ; ʼ1
    out dx, al                ; д
    mov dx, io8259_slave       ; io8259_slaveĵֵַdxĴ
    mov al, 00001000b         ; ʼ2
    out dx, al                ; д
    mov al, 00000001b         ; ʼ4
    out dx, al                ; д

    ; ж
    push    ds
    mov ax, 0
    mov ds, ax
    lea ax, cs:interrupt_handler
    mov si, 08h              ; MIR0Ϊ08h
    add si, si
    add si, si
    mov ds:[si], ax          ; жϷĵַ洢ж
    push    cs
    pop ax
    mov ds:[si+2], ax        ; жеcsλ
    pop ds
    in  al, dx
    and al, 11111110b
    out dx, al

    ; ʼ8253Ƶ
    mov ax, 0
    mov al, 00110110b         ; 8253ƵĿ
    mov dx, io8253_control
    out dx, al
    mov ax, 10000             ; üֵ
    mov dx, io8253_channel_0
    out dx, al
    mov al, ah
    out dx, al

    ; ʼ8255оƬ
    mov dx, io8255_control
    mov al, 10001000b         ; 8255
    out dx, al

    mov motor_phase, 33h      ; ʼ
    sti                     ; ж

    ; AD0809תѭ
adc_conversion_loop:
    mov dx, ad_start
    out dx, al               ; ADת
adc_wait:
    mov dx, ad_end_of_conv
    in  al, dx               ; תǷ
    test    al, 01h
    jz  adc_wait             ; תδɣȴ
    mov dx, ad_output_enable
    in  al, dx               ; ȡADת
    mov adc_value, al

;------------------------------------------------------------------
motor_control:
    mov al, motor_phase      ; ȡǰ
    mov dx, io8255_port_c
    out dx, al               ; 򵽶˿C

motor_delay_loop:
    call    delay            ; ʱ
    mov dx, io8255_port_c
    in  al, dx               ; ȡ

motor_direction_check:
    test    al, 80h          ; 
    jnz motor_reverse        ; Ϊתתת
    mov al, motor_phase
    ror al, 1                ; ת
    jmp motor_update         ; ת
motor_reverse:
    mov al, motor_phase
    rol al, 1                ; ת
motor_update:
    mov dx, io8255_port_c
    out dx, al               ; µĵ
    mov motor_phase, al      ; µ

;-----------------------------------ͨʾ--------------------------
traffic_light_control:
    call    display_countdown  ; õʱʾ
    mov dx, io8255_port_b
green_light_main:
    cmp interrupt_count, 500  ; жǷ񵽴5룬ɵ̵
    ja  yellow_light_main
    mov al, traffic_light_states
    out dx, al                ; ̵״̬
    jmp traffic_light_end
yellow_light_main:
    cmp interrupt_count, 700  ; жǷ񵽴7룬ɵƵ
    ja  green_light_side
    mov al, traffic_light_states[1]
    out dx, al                ; Ƶ״̬
    jmp traffic_light_end
green_light_side:
    cmp interrupt_count, 1000 ; жǷ񵽴10룬Ӹɵ̵
    ja  yellow_light_side
    mov al, traffic_light_states[2]
    out dx, al                ; ̵״̬
    jmp traffic_light_end
yellow_light_side:
    cmp interrupt_count, 1200 ; жǷ񵽴12룬ӸɵƵ
    ja  traffic_cycle_end
    mov al, traffic_light_states[3]
    out dx, al                ; Ƶ״̬
    jmp traffic_light_end
traffic_cycle_end:
    mov interrupt_count, 0    ; ѭü
traffic_light_end:
    call    display_countdown  ; õʱʾ
    jmp adc_conversion_loop   ; תADתѭ

;---------------------------ʱʾ-----------------------------
display_countdown proc
begin:
    mov dx, io8255_port_a
segment_5:
    cmp interrupt_count, 100
    ja  segment_4
    mov al, 6dh
    out dx, al
    jmp display_exit
segment_4:
    cmp interrupt_count, 200
    ja  segment_3
    mov al, 66h
    out dx, al
    jmp display_exit
segment_3:
    cmp interrupt_count, 300
    ja  segment_2
    mov al, 4fh
    out dx, al
    jmp display_exit
segment_2:
    cmp interrupt_count, 400
    ja  segment_1
    mov al, 5bh
    out dx, al
    jmp display_exit
segment_1:
    cmp interrupt_count, 500
    ja  segment_6
    mov al, 06h
    out dx, al
    jmp display_exit
segment_6:
    cmp interrupt_count, 600
    ja  segment_7
    mov al, 5bh
    out dx, al
    jmp display_exit
segment_7:
    cmp interrupt_count, 700
    ja  segment_8
    mov al, 06h
    out dx, al
    jmp display_exit
segment_8:
    cmp interrupt_count, 800
    ja  segment_9
    mov al, 4fh
    out dx, al
    jmp display_exit
segment_9:
    cmp interrupt_count, 900
    ja  segment_10
    mov al, 5bh
    out dx, al
    jmp display_exit
segment_10:
    cmp interrupt_count, 1000
    ja  segment_11
    mov al, 06h
    out dx, al
    jmp display_exit
segment_11:
    cmp interrupt_count, 1100
    ja  segment_12
    mov al, 5bh
    out dx, al
    jmp display_exit
segment_12:
    cmp interrupt_count, 1200
    ja  display_exit
    mov al, 06h
    out dx, al
display_exit:
    ret
display_countdown endp

;------------------------------ʱ---------------------------------
delay   proc    near
    push    ax
    push    cx
    push    dx
    mov dl, adc_value
loop_outer:
    mov cx, 0ffh
loop_inner:
    loop    loop_inner
    dec dl
    jnz loop_outer
    pop dx
    pop cx
    pop ax
    ret
delay   endp

;-----------------------------жϷ---------------------------------
interrupt_handler    proc    far
    push    ax
    push    dx
increment_counter:
    inc interrupt_count  ; жϼ1
    mov al, 20h          ; EOIж
    mov dx, io8259_master
    out dx, al
    pop dx
    pop ax
    sti                  ; ж
    iret                 ; жϷ
interrupt_handler    endp

code    ends
end start
